## repowerd 2023.07

=== CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

project(repowerd)

set(REPOWERD_VERSION "2023.07")

cmake_minimum_required(VERSION 3.0)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

option(REPOWERD_BUILD_TESTS "Build tests" ON)
option(REPOWERD_DISABLE_TIME_SENSITIVE_TESTS "Don't run time-sensitive tests" OFF)

option(REPOWERD_ENABLE_HYBRIS "Enable hybris support" ON)
option(REPOWERD_ENABLE_BINDER "Enable binder support" ON)

# Work around cmake setting conf dir to "/usr/etc" instead of "/etc"
# when prefix is "/usr"
if (NOT DEFINED CMAKE_INSTALL_SYSCONFDIR AND CMAKE_INSTALL_PREFIX STREQUAL "/usr")
    set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()

enable_testing()
include(GNUInstallDirs)
find_package(Threads REQUIRED)
find_package(PkgConfig REQUIRED)

pkg_check_modules(DEVICEINFO REQUIRED deviceinfo)
pkg_check_modules(GIO REQUIRED gio-2.0)
pkg_check_modules(GIO_UNIX REQUIRED gio-unix-2.0)

if (REPOWERD_ENABLE_HYBRIS)
    pkg_check_modules(UA REQUIRED ubuntu-platform-api)
    pkg_check_modules(LIBHARDWARE REQUIRED libhardware)
    pkg_check_modules(UBUNTU_PLATFORM_HARDWARE_API REQUIRED ubuntu-platform-hardware-api)
    find_package(AndroidHeaders REQUIRED)
endif()
if (REPOWERD_ENABLE_BINDER)
    pkg_check_modules(GBINDER REQUIRED libgbinder)
endif()

set(build_types "None;Debug;Release;RelWithDebInfo;MinSizeRel;AddressSanitizer;ThreadSanitizer")
# Change informational string for CMAKE_BUILD_TYPE
set(CMAKE_BUILD_TYPE ${CMAKE_BUILD_TYPE} CACHE STRING "${build_types}" FORCE)
# Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")

set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -pthread -std=c11 -Werror -Wall -Wextra -pedantic")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -pthread -std=c++14 -Werror -Wall -Wnon-virtual-dtor -Wextra -pedantic")

string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

if(cmake_build_type_lower MATCHES "addresssanitizer")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address -fno-omit-frame-pointer")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=address")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=address")
elseif(cmake_build_type_lower MATCHES "threadsanitizer")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=thread -fno-omit-frame-pointer")
    set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -fsanitize=thread")
    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -fsanitize=thread")
    link_libraries(tsan) # Workaround for LP:1413474
endif()

set(POWERD_DEVICE_CONFIG_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/powerd/device_configs")
set(REPOWERD_DEVICE_CONFIG_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/repowerd/device-configs")

add_definitions(-DREPOWERD_VERSION="${REPOWERD_VERSION}")

add_subdirectory(src/)
add_subdirectory(data/)

if(REPOWERD_BUILD_TESTS)
    find_package(GMock REQUIRED)
    add_subdirectory(tests/)
endif()

=== src/adapters/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

add_subdirectory(libsuspend)

if (REPOWERD_ENABLE_HYBRIS)
    set(REPOWERD_ADAPTER_HYBRIS_SRCS
        android_backlight.cpp
        dev_alarm_wakeup_service.cpp
        ubuntu_light_sensor.cpp
        ubuntu_performance_booster.cpp
        ubuntu_proximity_sensor.cpp
    )
endif()

if (REPOWERD_ENABLE_BINDER)
    set(REPOWERD_ADAPTER_BINDER_SRCS
        binder_performance_booster.cpp
    )
endif()

set(
    REPOWERD_ADAPTER_SRCS

    android_autobrightness_algorithm.cpp
    android_device_config.cpp
    android_device_quirks.cpp
    backlight_brightness_control.cpp
    brightness_params.cpp
    console_log.cpp
    dbus_connection_handle.cpp
    dbus_event_loop.cpp
    dbus_message_handle.cpp
    default_state_machine_options.cpp
    fs_double_tap_to_wake.cpp
    event_loop.cpp
    event_loop_timer.cpp
    fd.cpp
    libsuspend_system_power_control.cpp
    logind_session_tracker.cpp
    logind_system_power_control.cpp
    lsc_display.cpp
    lsc_power_button.cpp
    lsc_user_activity.cpp
    monotone_spline.cpp
    null_log.cpp
    ofono_voice_call_service.cpp
    path.cpp
    real_chrono.cpp
    real_device_info.cpp
    real_filesystem.cpp
    real_temporary_suspend_inhibition.cpp
    repowerd_settings_service.cpp
    syslog_log.cpp
    sysfs_backlight.cpp
    timerfd_wakeup_service.cpp
    unity_screen_service.cpp
    upower_power_source_and_lid.cpp

    sensorfw/sensorfw_common.cpp
    sensorfw/sensorfw_light_sensor.cpp
    sensorfw/sensorfw_proximity_sensor.cpp
    sensorfw/socketreader.cpp

    ${REPOWERD_ADAPTER_HYBRIS_SRCS}
    ${REPOWERD_ADAPTER_BINDER_SRCS}
)

add_library(
    repowerd-adapters STATIC
    ${REPOWERD_ADAPTER_SRCS}
)

target_link_libraries(
    repowerd-adapters

    suspend
    ${DEVICEINFO_LDFLAGS}
    ${GIO_LDFLAGS} ${GIO_LIBRARIES}
    ${GIO_UNIX_LDFLAGS} ${GIO_UNIX_LIBRARIES}
    ${LIBHARDWARE_LDFLAGS} ${LIBHARDWARE_LIBRARIES}
    ${UA_LDFLAGS} ${UA_LIBRARIES}
    ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS} ${UBUNTU_PLATFORM_HARDWARE_API_LIBRARIES}
    ${GBINDER_LDFLAGS} ${GBINDER_LIBRARIES}
)

target_include_directories(
    repowerd-adapters PUBLIC

    ${DEVICEINFO_INCLUDE_DIRS}
    ${GIO_INCLUDE_DIRS}
    ${GIO_UNIX_INCLUDE_DIRS}
    ${LIBHARDWARE_INCLUDE_DIRS}
    ${UA_INCLUDE_DIRS}
    ${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS}
    ${GBINDER_INCLUDE_DIRS}
)

=== tests/adapter-tests/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

if (REPOWERD_ENABLE_HYBRIS)
    set(REPOWERD_ADAPTER_TEST_HYBRIS_SRCS
        fake_libhardware.cpp

        test_android_backlight.cpp
        test_dev_alarm_wakeup_service.cpp
        test_ubuntu_light_sensor.cpp
        test_ubuntu_proximity_sensor.cpp
    )
endif()

add_executable(
    repowerd-adapter-tests

    current_thread_name.cpp
    dbus_bus.cpp
    dbus_client.cpp
    fake_device_info.cpp
    fake_brightness_notification.cpp
    fake_chrono.cpp
    fake_device_config.cpp
    fake_device_quirks.cpp
    fake_double_tap_to_wake.cpp
    fake_filesystem.cpp
    fake_logind.cpp
    fake_ofono.cpp
    fake_upower.cpp
    fake_wakeup_service.cpp
    repowerd_settings_dbus_client.cpp
    run_command.cpp
    temporary_environment_value.cpp
    temporary_file.cpp
    unity_screen_dbus_client.cpp

    test_android_autobrightness_algorithm.cpp
    test_android_device_config.cpp
    test_android_device_quirks.cpp
    test_backlight_brightness_control.cpp
    test_brightness_params.cpp
    test_dbus_event_loop.cpp
    test_default_state_machine_options.cpp
    test_event_loop.cpp
    test_event_loop_timer.cpp
    test_fd.cpp
    test_logind_session_tracker.cpp
    test_logind_system_power_control.cpp
    test_lsc_display.cpp
    test_lsc_power_button.cpp
    test_lsc_user_activity.cpp
    test_monotone_spline.cpp
    test_ofono_voice_call_service.cpp
    test_path.cpp
    test_real_chrono.cpp
    test_real_filesystem.cpp
    test_real_temporary_suspend_inhibition.cpp
    test_repowerd_service.cpp
    test_repowerd_settings_service.cpp
    test_sysfs_backlight.cpp
    test_timerfd_wakeup_service.cpp
    test_unique_random_pool.cpp
    test_unity_screen_service.cpp
    test_upower_power_source_and_lid.cpp

    ${REPOWERD_ADAPTER_TEST_HYBRIS_SRCS}
)

target_link_libraries(
    repowerd-adapter-tests

    repowerd-core
    repowerd-adapters
    repowerd-test-common

    ${GTEST_LIBRARY}
    ${GMOCK_LIBRARIES}
)

if (REPOWERD_DISABLE_TIME_SENSITIVE_TESTS)
    set(
        ADAPTER_TESTS_FILTER
        "${ADAPTER_TESTS_FILTER}:\
         ARealChrono.*:\
         AnEventLoopTimer.*:\
         ARealTemporarySuspendInhibition.*:\
         ATimerfdWakeupService.*:\
         AnLscDisplay.waits_at_most_one_second_for_turn_on_response"
    )
    string(REPLACE " " "" ADAPTER_TESTS_FILTER ${ADAPTER_TESTS_FILTER})
endif()

add_test(
    repowerd-adapter-tests
    ${EXECUTABLE_OUTPUT_PATH}/repowerd-adapter-tests --gtest_filter=-${ADAPTER_TESTS_FILTER}
)

=== tests/common/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

add_library(
    repowerd-test-common STATIC

    fake_log.cpp
    fake_system_power_control.cpp
    spin_wait.cpp
)

target_link_libraries(
    repowerd-test-common

    repowerd-core

    ${GTEST_LIBRARY}
    ${GMOCK_LIBRARIES}
)

=== tests/core-tests/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

add_executable(
    repowerd-core-tests

    acceptance_test.cpp
    daemon_config.cpp
    fake_display_information.cpp
    fake_client_requests.cpp
    fake_client_settings.cpp
    fake_lid.cpp
    fake_notification_service.cpp
    fake_power_button.cpp
    fake_power_source.cpp
    fake_proximity_sensor.cpp
    fake_session_tracker.cpp
    fake_state_machine_options.cpp
    fake_timer.cpp
    fake_user_activity.cpp
    fake_voice_call_service.cpp

    run_daemon.cpp

    test_client_requests.cpp
    test_client_settings.cpp
    test_treat_power_button_as_user_activity.cpp
    test_daemon.cpp
    test_fake_timer.cpp
    test_handler_registration.cpp
    test_lid.cpp
    test_modem_power_control.cpp
    test_notification.cpp
    test_performance_booster.cpp
    test_power_button.cpp
    test_power_source.cpp
    test_proximity_sensor.cpp
    test_session.cpp
    test_system_power_control.cpp
    test_turn_on_display_at_startup.cpp
    test_user_activity.cpp
    test_voice_call.cpp
)

target_link_libraries(
    repowerd-core-tests

    repowerd-core
    repowerd-test-common

    ${GTEST_LIBRARY}
    ${GMOCK_LIBRARIES}
)

add_test(repowerd-core-tests ${EXECUTABLE_OUTPUT_PATH}/repowerd-core-tests)

=== debian/changelog ===
repowerd (2023.07-4build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:55:01 +1100

repowerd (2023.07-4) unstable; urgency=medium

  * debian/patches:
    + Add 1003_add-enable-Werror-CMake-option.patch. Add -DENABLE_WERROR option
      to CMake options and let it default to OFF. (This fixes FTBFS of
      repowered in Ubuntu due to LTO-related compiler warnings popping up when
      building on Ubuntu).

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 04 Mar 2024 10:20:22 +0100

repowerd (2023.07-3) unstable; urgency=medium

  * debian/changelog:
    + Fix attribution/author of changes in previous upload.
  * debian/control:
    + Add B-D: systemd-dev [linux-any].

 -- Mike Gabriel <sunweaver@debian.org>  Fri, 01 Mar 2024 23:26:49 +0100

repowerd (2023.07-2) unstable; urgency=medium

  [ Alfred Neumayer ]
  * debian/patches:
    + Add 0001_enable-builds-without-lsc.patch. Enable builds without lsc
      integration.
    + Add 0002_sysfs-path-thinpad-x13s.patch. src/adapters: Enable sysfs
      path used by Thinkpad x13s. Enables control of brightness slider.

  [ Mike Gabriel ]
  * debian/patches:
    + Add 1001_typo-fix.patch.
    + Add 1002_fix-tests-when-building-without-lsc-support.patch. Band-aid
      unit tests when building with -DREPOWERD_ENABLE_LSC=OFF.
  * debian/rules:
    + Build with -DREPOWERD_ENABLE_LSC=OFF.
  * debian/copyright:
    + Update auto-generated copyright.in file.
    + Update copyright attributions.
  * debian/repowerd.{service,install}:
    + Use upstream's systemd service file.
  * lintian: Update overrides (mostly syntax fixes, add dbus-policy-in-etc
    overrides, drop package-supports-alternative-init-but-no-init.d-script.
  * debian/control:
    + In B-D: field, switch from pkg-config to pkgconf. Thanks, lintian.
    + Bump Standards-Version: to 4.6.2. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Sun, 25 Feb 2024 20:50:33 +0000

repowerd (2023.07-1) unstable; urgency=medium

  * New upstream release (closes: #1037839)
  * debian/control: Drop uneeded B-D and add deviceinfo-dev
  * debian/patches: Drop upstreamed patches
  * debian/rules: Don't build the binder plugin (only for android/hybris devices)
  * debian/copyright: Update to match upstream

 -- Marius Gripsgard <mariogrip@debian.org>  Thu, 27 Jul 2023 03:24:14 +0200

repowerd (2022.01-3) unstable; urgency=medium

  * debian/:
    + Update upstream Git repo URL.
  * debian/control:
    + Bump Standards-Version: to 4.6.1. No changes needed.

 -- Mike Gabriel <sunweaver@debian.org>  Mon, 25 Jul 2022 17:05:57 +0200

repowerd (2022.01-2) unstable; urgency=medium

  * Source-only upload as-is.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 05 Mar 2022 11:51:08 +0100

=== debian/control ===
Source: repowerd
Priority: optional
Section: admin
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
Uploaders:
 Mike Gabriel <sunweaver@debian.org>,
Build-Depends: debhelper-compat (= 13),
               cmake,
               cmake-extras,
               dbus,
               googletest | google-mock,
               libglib2.0-dev,
               libgtest-dev,
               libdeviceinfo-dev,
               pkgconf,
               systemd-dev [linux-any],
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://gitlab.com/ubports/development/core/repowerd/
Vcs-Browser: https://salsa.debian.org/ubports-team/repowerd/
Vcs-Git: https://salsa.debian.org/ubports-team/repowerd.git

Package: repowerd
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         repowerd-data (= ${source:Version})
Breaks: powerd,
Replaces: powerd,
Description: Power daemon to monitor and control system power state (daemon)
 This daemon monitors and controls system power states for the Lomiri
 Operating Environment. It provides a D-Bus interface for system services
 to request a power state, essentially allowing services to block
 suspend.
 .
 This package contains repowerd daemon itself.

Package: repowerd-data
Architecture: all
Depends: ${misc:Depends}
Breaks: powerd,
Replaces: powerd,
Description: Power daemon to monitor and control system power state (daemon data)
 This daemon monitors and controls system power states for the Lomiri
 Operating Environment. It provides a D-Bus interface for system services
 to request a power state, essentially allowing services to block
 suspend.
 .
 This package contains data files needed by repowerd.

Package: repowerd-tools
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         repowerd-data (= ${source:Version})
Description: Power daemon to monitor and control system power state (tools)
 This daemon monitors and controls system power states for the Lomiri
 Operating Environment. It provides a D-Bus interface for system services
 to request a power state, essentially allowing services to block
 suspend.
 .
 This package contains tools that use the repowerd infrastructure to interact
 with various hardware components. These tools are mainly useful for manual
 integration testing.

=== debian/watch ===
version=4
https://gitlab.com/ubports/development/core/repowerd/tags .*/repowerd-(\d\S+)\.tar\.gz

## repowerd 2025.09

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,12 +16,13 @@
 
 project(repowerd)
 
-set(REPOWERD_VERSION "2023.07")
+set(REPOWERD_VERSION "2025.09")
 
-cmake_minimum_required(VERSION 3.0)
+cmake_minimum_required(VERSION 3.10)
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
 
 option(REPOWERD_BUILD_TESTS "Build tests" ON)
+option(ENABLE_WERROR "Treat all build warnings as errors" OFF)
 option(REPOWERD_DISABLE_TIME_SENSITIVE_TESTS "Don't run time-sensitive tests" OFF)
 
 option(REPOWERD_ENABLE_HYBRIS "Enable hybris support" ON)
@@ -43,10 +44,8 @@
 pkg_check_modules(GIO_UNIX REQUIRED gio-unix-2.0)
 
 if (REPOWERD_ENABLE_HYBRIS)
-    pkg_check_modules(UA REQUIRED ubuntu-platform-api)
-    pkg_check_modules(LIBHARDWARE REQUIRED libhardware)
-    pkg_check_modules(UBUNTU_PLATFORM_HARDWARE_API REQUIRED ubuntu-platform-hardware-api)
-    find_package(AndroidHeaders REQUIRED)
+    find_library(Hybris NAMES hybris-common REQUIRED)
+    pkg_check_modules(ANDROIDPROPERTIES REQUIRED libandroid-properties)
 endif()
 if (REPOWERD_ENABLE_BINDER)
     pkg_check_modules(GBINDER REQUIRED libgbinder)
@@ -58,9 +57,17 @@
 # Enable cmake-gui to display a drop down list for CMAKE_BUILD_TYPE
 set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "${build_types}")
 
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+set(CMAKE_CXX_EXTENSIONS OFF)
+
 set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)
-set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -pthread -std=c11 -Werror -Wall -Wextra -pedantic")
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -pthread -std=c++14 -Werror -Wall -Wnon-virtual-dtor -Wextra -pedantic")
+set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -pthread -std=c11 -Wall -Wextra -pedantic")
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -pthread -Wall -Wnon-virtual-dtor -Wextra -pedantic")
+
+if(ENABLE_WERROR)
+    add_compile_options("-Werror")
+endif()
 
 string(TOLOWER "${CMAKE_BUILD_TYPE}" cmake_build_type_lower)

=== data/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

FILE(GLOB device_config_files "${CMAKE_CURRENT_SOURCE_DIR}/device-configs/*.xml")
FILE(GLOB dbus_config_files "${CMAKE_CURRENT_SOURCE_DIR}/dbus-configs/*.conf")
FILE(GLOB systemd_file "${CMAKE_CURRENT_SOURCE_DIR}/repowerd.service")

install(
  FILES ${device_config_files}
  DESTINATION ${REPOWERD_DEVICE_CONFIG_DIR}
)

install(
  FILES ${dbus_config_files}
  DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/dbus-1/system.d
)

pkg_check_modules(SYSTEMD systemd)
if (${SYSTEMD_FOUND})
  pkg_get_variable(SYSTEMD_SYSTEM_DIR systemd systemdsystemunitdir)
  message (STATUS "${SYSTEMD_SYSTEM_DIR} is the systemd system unit file install dir")
  install (FILES "${systemd_file}"  DESTINATION "${SYSTEMD_SYSTEM_DIR}")
endif()

=== src/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

add_definitions(-DPOWERD_DEVICE_CONFIG_DIR=\"${POWERD_DEVICE_CONFIG_DIR}\")
add_definitions(-DREPOWERD_DEVICE_CONFIG_DIR=\"${REPOWERD_DEVICE_CONFIG_DIR}\")

include_directories(
    ${CMAKE_SOURCE_DIR}
)

if (REPOWERD_ENABLE_HYBRIS)
    add_definitions(-DREPOWERD_ENABLE_HYBRIS)
endif()
if (REPOWERD_ENABLE_BINDER)
    add_definitions(-DREPOWERD_ENABLE_BINDER)
endif()

add_subdirectory(core)
add_subdirectory(adapters)
add_subdirectory(tools)

add_library(
    repowerd-default-daemon-config STATIC

    default_daemon_config.cpp
)

target_link_libraries(
    repowerd-default-daemon-config

    repowerd-core
    repowerd-adapters
)

add_executable(
    repowerd

    main.cpp
)

target_link_libraries(
    repowerd

    repowerd-core
    repowerd-adapters
    repowerd-default-daemon-config
)


install(
  TARGETS repowerd
  RUNTIME DESTINATION sbin
)

=== tests/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

include_directories(
    ${CMAKE_SOURCE_DIR}
    ${GMOCK_INCLUDE_DIR}
    ${GTEST_INCLUDE_DIR}
    common
)

add_subdirectory(adapter-tests/)
add_subdirectory(core-tests/)
add_subdirectory(common/)

=== src/adapters/CMakeLists.txt ===
--- 
+++ 
@@ -18,11 +18,7 @@
 
 if (REPOWERD_ENABLE_HYBRIS)
     set(REPOWERD_ADAPTER_HYBRIS_SRCS
-        android_backlight.cpp
-        dev_alarm_wakeup_service.cpp
-        ubuntu_light_sensor.cpp
-        ubuntu_performance_booster.cpp
-        ubuntu_proximity_sensor.cpp
+        qti_perf_performance_booster.cpp
     )
 endif()
 
@@ -91,10 +87,9 @@
     ${DEVICEINFO_LDFLAGS}
     ${GIO_LDFLAGS} ${GIO_LIBRARIES}
     ${GIO_UNIX_LDFLAGS} ${GIO_UNIX_LIBRARIES}
-    ${LIBHARDWARE_LDFLAGS} ${LIBHARDWARE_LIBRARIES}
-    ${UA_LDFLAGS} ${UA_LIBRARIES}
-    ${UBUNTU_PLATFORM_HARDWARE_API_LDFLAGS} ${UBUNTU_PLATFORM_HARDWARE_API_LIBRARIES}
     ${GBINDER_LDFLAGS} ${GBINDER_LIBRARIES}
+    ${Hybris}
+    ${ANDROIDPROPERTIES_LDFLAGS} ${ANDROIDPROPERTIES_LIBRARIES}
 )
 
 target_include_directories(
@@ -103,8 +98,6 @@
     ${DEVICEINFO_INCLUDE_DIRS}
     ${GIO_INCLUDE_DIRS}
     ${GIO_UNIX_INCLUDE_DIRS}
-    ${LIBHARDWARE_INCLUDE_DIRS}
-    ${UA_INCLUDE_DIRS}
-    ${UBUNTU_PLATFORM_HARDWARE_API_INCLUDE_DIRS}
     ${GBINDER_INCLUDE_DIRS}
+    ${ANDROIDPROPERTIES_INCLUDE_DIRS}
 )

=== src/core/CMakeLists.txt ===
# Copyright © 2016 Canonical Ltd.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>

set(
    REPOWERD_CORE_SRCS
    daemon.cpp
    default_state_machine.cpp
    default_state_machine_factory.cpp
    handler_registration.cpp
    log.cpp
    state_event_adapter.cpp
)

add_library(
    repowerd-core STATIC
    ${REPOWERD_CORE_SRCS}
)

=== tests/adapter-tests/CMakeLists.txt ===
--- 
+++ 
@@ -13,17 +13,6 @@
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Authored by: Alexandros Frantzis <alexandros.frantzis@canonical.com>
-
-if (REPOWERD_ENABLE_HYBRIS)
-    set(REPOWERD_ADAPTER_TEST_HYBRIS_SRCS
-        fake_libhardware.cpp
-
-        test_android_backlight.cpp
-        test_dev_alarm_wakeup_service.cpp
-        test_ubuntu_light_sensor.cpp
-        test_ubuntu_proximity_sensor.cpp
-    )
-endif()
 
 add_executable(
     repowerd-adapter-tests

=== src/adapters/libsuspend/CMakeLists.txt ===
add_library(
  suspend STATIC

  libsuspend.c
  sysfs.c
  autosleep.c
  earlysuspend.c
  legacy.c
  mocksuspend.c
)

=== debian/changelog ===
repowerd (2025.09-1) unstable; urgency=medium

  * New upstream release.
  * debian/patches:
    + Drop 1001_typo-fix.patch and 1003_add-enable-Werror-CMake-option.patch.
      Both applied upstream.
    + Trivially rebase remaining patches.
    + Add 1003_fix-gcc-15.patch. Fix FTBFS against GCC 15. Add missing include.
      (Closes: #1097789).
    + Add 1004_disable-performance-tests-if-building-without-hybris-
      support.patch. Exclude APerformance Booster tests from unit tests if
      building without hybris support.
  * debian/control:
    + Bump Standards-Version: to 4.7.2. No changes needed.
  * debian/copyright:
    + Update copyright attributions.
  * debian/watch:
    + Update file for recent GitLab changes of the tags overview page.

 -- Mike Gabriel <sunweaver@debian.org>  Sat, 13 Sep 2025 18:27:17 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: repowerd
 Priority: optional
 Section: admin
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
+Maintainer: Debian UBports Team <team+ubports@tracker.debian.org>
 Uploaders:
  Mike Gabriel <sunweaver@debian.org>,
 Build-Depends: debhelper-compat (= 13),
@@ -15,7 +14,7 @@
                libdeviceinfo-dev,
                pkgconf,
                systemd-dev [linux-any],
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://gitlab.com/ubports/development/core/repowerd/
 Vcs-Browser: https://salsa.debian.org/ubports-team/repowerd/

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/buildflags.mk
# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_missing:
	dh_missing --fail-missing

override_dh_auto_configure:
	dh_auto_configure -- \
		-DREPOWERD_ENABLE_HYBRIS=OFF \
		-DREPOWERD_ENABLE_BINDER=OFF \
		-DREPOWERD_ENABLE_LSC=OFF \
		-DREPOWERD_DISABLE_TIME_SENSITIVE_TESTS=ON

get-orig-source:
	uscan --noconf --force-download --rename --download-current-version --destdir=..
